rules_version = '2';
service cloud.firestore {
  match /databases/{database}/documents {
    match /tokens/{userid} {
      allow read, write: if userid == request.auth.uid;
    }
    
    match /media/{document=**} {
      allow read
      allow write: if 
          request.auth != null && exists(/databases/$(database)/documents/config/userRoles/users/$(request.auth.token.email))
    }
    
    match /langs/{document=**} {
      allow read
      allow write: if 
          request.auth != null && exists(/databases/$(database)/documents/config/userRoles/users/$(request.auth.token.email))
    }
   
    match /submissions/{document=**} {
      allow read
      allow write: if 
          request.auth != null && exists(/databases/$(database)/documents/config/userRoles/users/$(request.auth.token.email))
      allow update: if (request.resource.data.diff(resource.data).affectedKeys()
          .hasOnly(['status']));
    }
    
    match /users/{document=**} {
      allow read
      allow write: if 
          request.auth != null && exists(/databases/$(database)/documents/config/userRoles/users/$(request.auth.token.email))
    }
    
    match /config/{document=**} {
      allow read
    }
      
    match /judgingallocation/{document=**} {
      allow read,write: if 
				  request.auth != null && 
          get(/databases/$(database)/documents/anonymousUser/$(request.auth.uid)).data.code 
        	    == resource.data.code
    }
  	
    match /judgingcriteria/{document=**} {
      allow read
    }
    
    match /anonymousUser/{document=**} {
      allow read, write
    } 
  }
}